package exnihilocreatio.recipes.defaults;

import exnihilocreatio.ExNihiloCreatio;
import exnihilocreatio.ModBlocks;
import exnihilocreatio.ModFluids;
import exnihilocreatio.ModItems;
import exnihilocreatio.blocks.BlockSieve.MeshType;
import exnihilocreatio.config.ModConfig;
import exnihilocreatio.items.ItemResource;
import exnihilocreatio.items.ore.ItemOre;
import exnihilocreatio.items.seeds.ItemSeedBase;
import exnihilocreatio.registries.manager.ExNihiloRegistryManager;
import exnihilocreatio.registries.registries.*;
import exnihilocreatio.registries.types.Meltable;
import exnihilocreatio.texturing.Color;
import exnihilocreatio.util.BlockInfo;
import exnihilocreatio.util.ItemInfo;
import exnihilocreatio.util.Util;
import lombok.Getter;
import net.minecraft.block.Block;
import net.minecraft.block.BlockLeaves;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.oredict.OreDictionary;

import java.util.LinkedHashMap;
import java.util.Map;

public class ExNihilo implements IRecipeDefaults {
    @Getter
    public String MODID = ExNihiloCreatio.MODID;


    public void registerCompost(CompostRegistry registry) {
        BlockInfo dirtState = new BlockInfo(Blocks.field_150346_d);

        registry.register("treeSapling", 0.125f, dirtState);
        registry.register("treeLeaves", 0.125f, dirtState);
        registry.register("flower", 0.1f, dirtState);
        registry.register("fish", 0.15f, dirtState);
        registry.register("listAllmeatcooked", 0.20f, dirtState);

        registry.register(new ItemInfo(Items.field_151078_bh), 0.1f, dirtState, new Color("C45631"));

        registry.register(new ItemInfo(Items.field_151070_bp), 0.08f, dirtState, new Color("963E44"));

        registry.register(new ItemInfo(Items.field_151015_O), 0.08f, dirtState, new Color("E3E162"));
        registry.register(new ItemInfo(Items.field_151014_N), 0.08f, dirtState, new Color("35A82A"));
        registry.register(new ItemInfo(Items.field_151025_P), 0.16f, dirtState, new Color("D1AF60"));

        registry.register(new BlockInfo(Blocks.field_150338_P), 0.10f, dirtState, new Color("CFBFB6"));
        registry.register(new BlockInfo(Blocks.field_150337_Q), 0.10f, dirtState, new Color("D6A8A5"));

        registry.register(new ItemInfo(Items.field_151158_bO), 0.16f, dirtState, new Color("E39A6D"));

        registry.register(new ItemInfo(Items.field_151147_al), 0.2f, dirtState, new Color("FFA091"));
        registry.register(new ItemInfo(Items.field_151082_bd), 0.2f, dirtState, new Color("FF4242"));
        registry.register(new ItemInfo(Items.field_151076_bf), 0.2f, dirtState, new Color("FFE8E8"));

        registry.register(new ItemInfo(ModItems.resources, ItemResource.getMetaFromName(ItemResource.SILKWORM)), 0.04f, dirtState, new Color("ff9966"));
        registry.register(new ItemInfo(ModItems.cookedSilkworm), 0.04f, dirtState, new Color("cc6600"));

        registry.register(new ItemInfo(Items.field_151034_e), 0.10f, dirtState, new Color("FFF68F"));
        registry.register(new ItemInfo(Items.field_151127_ba), 0.04f, dirtState, new Color("FF443B"));
        registry.register(new BlockInfo(Blocks.field_150440_ba), 1.0f / 6, dirtState, new Color("FF443B"));
        registry.register(new BlockInfo(Blocks.field_150423_aK), 1.0f / 6, dirtState, new Color("FFDB66"));
        registry.register(new BlockInfo(Blocks.field_150428_aP), 1.0f / 6, dirtState, new Color("FFDB66"));

        registry.register(new BlockInfo(Blocks.field_150434_aF), 0.10f, dirtState, new Color("DEFFB5"));

        registry.register(new ItemInfo(Items.field_151172_bF), 0.08f, dirtState, new Color("FF9B0F"));
        registry.register(new ItemInfo(Items.field_151174_bG), 0.08f, dirtState, new Color("FFF1B5"));
        registry.register(new ItemInfo(Items.field_151168_bH), 0.08f, dirtState, new Color("FFF1B5"));
        registry.register(new ItemInfo(Items.field_151170_bI), 0.08f, dirtState, new Color("E0FF8A"));

        registry.register(new BlockInfo(Blocks.field_150392_bi.func_176223_P()), 0.10f, dirtState, new Color("269900"));
        registry.register(new BlockInfo(Blocks.field_150395_bd.func_176223_P()), 0.10f, dirtState, new Color("23630E"));
        registry.register(new BlockInfo(Blocks.field_150329_H, 1), 0.08f, dirtState, new Color("23630E"));
        registry.register(new ItemInfo(Items.field_151110_aK), 0.08f, dirtState, new Color("FFFA66"));
        registry.register(new ItemInfo(Items.field_151075_bm), 0.10f, dirtState, new Color("FF2B52"));
        registry.register(new ItemInfo(Items.field_151120_aE), 0.08f, dirtState, new Color("9BFF8A"));
        registry.register(new ItemInfo(Items.field_151007_F), 0.04f, dirtState, Util.whiteColor);

        //Register any missed items
        registry.register("listAllfruit", 0.10f, dirtState, new Color("35A82A"));
        registry.register("listAllveggie", 0.10f, dirtState, new Color("FFF1B5"));
        registry.register("listAllGrain", 0.08f, dirtState, new Color("E3E162"));
        registry.register("listAllseed", 0.08f, dirtState, new Color("35A82A"));
        registry.register("listAllmeatraw", 0.15f, dirtState, new Color("FFA091"));
    }

    public void registerCrook(CrookRegistry registry) {
        registry.register("treeLeaves", ItemResource.getResourceStack(ItemResource.SILKWORM), 0.1f, 0f);
    }

    public void registerSieve(SieveRegistry registry) {

        //Stone Pebble
        registry.register("dirt", new ItemInfo(ModItems.pebbles), getDropChance(1f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(ModItems.pebbles), getDropChance(1f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(ModItems.pebbles), getDropChance(0.5f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(ModItems.pebbles), getDropChance(0.5f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(ModItems.pebbles), getDropChance(0.1f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(ModItems.pebbles), getDropChance(0.1f), MeshType.STRING.getID());

        //Granite Pebble
        registry.register("dirt", new ItemInfo(ModItems.pebbles, 1), getDropChance(0.5f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(ModItems.pebbles, 1), getDropChance(0.1f), MeshType.STRING.getID());

        //Diorite Pebble
        registry.register("dirt", new ItemInfo(ModItems.pebbles, 2), getDropChance(0.5f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(ModItems.pebbles, 2), getDropChance(0.1f), MeshType.STRING.getID());

        //Andesite Pebble
        registry.register("dirt", new ItemInfo(ModItems.pebbles, 3), getDropChance(0.5f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(ModItems.pebbles, 3), getDropChance(0.1f), MeshType.STRING.getID());

        registry.register("dirt", new ItemInfo(Items.field_151014_N), getDropChance(0.7f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(Items.field_151081_bc), getDropChance(0.35f), MeshType.STRING.getID());
        registry.register("dirt", new ItemInfo(Items.field_151080_bb), getDropChance(0.35f), MeshType.STRING.getID());

        //Ancient Spores
        registry.register("dirt", new ItemInfo(ModItems.resources, 3), getDropChance(0.05f), MeshType.STRING.getID());
        //Grass Seeds
        registry.register("dirt", new ItemInfo(ModItems.resources, 4), getDropChance(0.05f), MeshType.STRING.getID());


        registry.register("sand", new ItemInfo(Items.field_151100_aR, 3), getDropChance(0.03f), MeshType.STRING.getID());
        registry.register("sand", new ItemInfo(Items.field_179562_cC), getDropChance(0.02f), MeshType.DIAMOND.getID());

        registry.register("gravel", new ItemInfo(Items.field_151145_ak), getDropChance(0.25f), MeshType.FLINT.getID());
        registry.register("gravel", new ItemInfo(Items.field_151044_h), getDropChance(0.125f), MeshType.FLINT.getID());
        registry.register("gravel", new ItemInfo(Items.field_151100_aR, 4), getDropChance(0.05f), MeshType.FLINT.getID());

        registry.register("gravel", new ItemInfo(Items.field_151045_i), getDropChance(0.008f), MeshType.IRON.getID());
        registry.register("gravel", new ItemInfo(Items.field_151166_bC), getDropChance(0.008f), MeshType.IRON.getID());

        registry.register("gravel", new ItemInfo(Items.field_151045_i), getDropChance(0.016f), MeshType.DIAMOND.getID());
        registry.register("gravel", new ItemInfo(Items.field_151166_bC), getDropChance(0.016f), MeshType.DIAMOND.getID());


        registry.register(new BlockInfo(Blocks.field_150425_aM), new ItemInfo(Items.field_151128_bU), getDropChance(1f), MeshType.FLINT.getID());
        registry.register(new BlockInfo(Blocks.field_150425_aM), new ItemInfo(Items.field_151128_bU), getDropChance(0.33f), MeshType.FLINT.getID());

        registry.register(new BlockInfo(Blocks.field_150425_aM), new ItemInfo(Items.field_151075_bm), getDropChance(0.1f), MeshType.STRING.getID());

        registry.register(new BlockInfo(Blocks.field_150425_aM), new ItemInfo(Items.field_151073_bk), getDropChance(0.02f), MeshType.DIAMOND.getID());
        registry.register(new BlockInfo(Blocks.field_150425_aM), new ItemInfo(Items.field_151128_bU), getDropChance(1f), MeshType.DIAMOND.getID());
        registry.register(new BlockInfo(Blocks.field_150425_aM), new ItemInfo(Items.field_151128_bU), getDropChance(0.8f), MeshType.DIAMOND.getID());

        registry.register("dust", new ItemInfo(Items.field_151100_aR, 15), getDropChance(0.2f), MeshType.STRING.getID());
        registry.register("dust", new ItemInfo(Items.field_151016_H), getDropChance(0.07f), MeshType.STRING.getID());

        registry.register("dust", new ItemInfo(Items.field_151137_ax), getDropChance(0.125f), MeshType.IRON.getID());
        registry.register("dust", new ItemInfo(Items.field_151137_ax), getDropChance(0.25f), MeshType.DIAMOND.getID());

        registry.register("dust", new ItemInfo(Items.field_151114_aO), getDropChance(0.0625f), MeshType.IRON.getID());
        registry.register("dust", new ItemInfo(Items.field_151065_br), getDropChance(0.05f), MeshType.IRON.getID());

        // Custom Ores for other mods
        OreRegistry oreRegistry = ExNihiloRegistryManager.ORE_REGISTRY;

        // Gold from nether rack
        ItemOre gold = oreRegistry.getOreItem("gold");
        if (gold != null) {
            registry.register(new BlockInfo(ModBlocks.netherrackCrushed), new ItemInfo(gold, 0), getDropChance(0.25f), MeshType.FLINT.getID());
            registry.register(new BlockInfo(ModBlocks.netherrackCrushed), new ItemInfo(gold, 0), getDropChance(0.25f), MeshType.IRON.getID());
            registry.register(new BlockInfo(ModBlocks.netherrackCrushed), new ItemInfo(gold, 0), getDropChance(0.4f), MeshType.DIAMOND.getID());
        }


        // All default Ores
        for (ItemOre ore : oreRegistry.getItemOreRegistry()) {
            if (oreRegistry.getSieveBlackList().contains(ore)) continue;
            registry.register("gravel", new ItemInfo(ore), getDropChance(0.2f), MeshType.FLINT.getID());
            registry.register("gravel", new ItemInfo(ore), getDropChance(0.2f), MeshType.IRON.getID());
            registry.register("gravel", new ItemInfo(ore), getDropChance(0.1f), MeshType.DIAMOND.getID());

        }
        // Seeds
        for (ItemSeedBase seed : ModItems.itemSeeds) {
            registry.register("dirt", new ItemInfo(seed), getDropChance(0.05f), MeshType.STRING.getID());
        }

        getLeavesSapling().forEach((leaves, sapling) -> {
            BlockLeaves blockLeaves = ((BlockLeaves) Block.func_149634_a(leaves.getItemStack().func_77973_b()));
            float chance = blockLeaves.func_176232_d(blockLeaves.func_176223_P()) / 100f;

            registry.register(leaves, sapling, Math.min(chance * 1, 1.0f), MeshType.STRING.getID());
            registry.register(leaves, sapling, Math.min(chance * 2, 1.0f), MeshType.FLINT.getID());
            registry.register(leaves, sapling, Math.min(chance * 3, 1.0f), MeshType.IRON.getID());
            registry.register(leaves, sapling, Math.min(chance * 4, 1.0f), MeshType.DIAMOND.getID());

            //Apple
            registry.register(leaves, new ItemInfo(Items.field_151034_e), 0.05f, MeshType.STRING.getID());
            registry.register(leaves, new ItemInfo(Items.field_151034_e), 0.10f, MeshType.FLINT.getID());
            registry.register(leaves, new ItemInfo(Items.field_151034_e), 0.15f, MeshType.IRON.getID());
            registry.register(leaves, new ItemInfo(Items.field_151034_e), 0.20f, MeshType.DIAMOND.getID());

            //Golden Apple
            registry.register(leaves, new ItemInfo(Items.field_151153_ao), 0.001f, MeshType.STRING.getID());
            registry.register(leaves, new ItemInfo(Items.field_151153_ao), 0.003f, MeshType.FLINT.getID());
            registry.register(leaves, new ItemInfo(Items.field_151153_ao), 0.005f, MeshType.IRON.getID());
            registry.register(leaves, new ItemInfo(Items.field_151153_ao), 0.01f, MeshType.DIAMOND.getID());

            //Silk Worm
            registry.register(leaves, new ItemInfo(ItemResource.getResourceStack(ItemResource.SILKWORM)), 0.025f, MeshType.STRING.getID());
            registry.register(leaves, new ItemInfo(ItemResource.getResourceStack(ItemResource.SILKWORM)), 0.05f, MeshType.FLINT.getID());
            registry.register(leaves, new ItemInfo(ItemResource.getResourceStack(ItemResource.SILKWORM)), 0.1f, MeshType.IRON.getID());
            registry.register(leaves, new ItemInfo(ItemResource.getResourceStack(ItemResource.SILKWORM)), 0.2f, MeshType.DIAMOND.getID());
        });
    }

    public void registerHammer(HammerRegistry registry) {
        registry.register("cobblestone", new ItemStack(Blocks.field_150351_n, 1), 0, 1.0F, 0.0F);
        registry.register("gravel", new ItemStack(Blocks.field_150354_m, 1), 0, 1.0F, 0.0F);
        registry.register("sand", new ItemStack(ModBlocks.dust, 1), 0, 1.0F, 0.0F);
        registry.register("netherrack", new ItemStack(ModBlocks.netherrackCrushed, 1), 0, 1.0F, 0.0F);
        registry.register("endstone", new ItemStack(ModBlocks.endstoneCrushed, 1), 0, 1.0F, 0.0F);

        registry.register("stoneAndesite", new ItemStack(ModBlocks.crushedAndesite), 0, 1f, 0);
        registry.register("stoneGranite", new ItemStack(ModBlocks.crushedGranite), 0, 1f, 0);
        registry.register("stoneDiorite", new ItemStack(ModBlocks.crushedDiorite), 0, 1f, 0);

        registry.register("crushedGranite", new ItemStack(Blocks.field_150354_m, 1, 1), 0, 1.0f, 0.0f);


        // Hammer concrete into concrete powder
        for (int meta = 0; meta < 16; meta++)
            registry.register(BlockInfo.getStateFromMeta(Blocks.field_192443_dR, meta), new ItemStack(Blocks.field_192444_dS, 1, meta), 1, 1.0f, 0.0f);

    }

    public void registerHeat(HeatRegistry registry) {
        // Vanilla fluids are weird, the "flowing" variant is simply a temporary state of checking if it can flow.
        // So, once the lava has spread out all the way, it will all actually be "still" lava.
        // Thanks Mojang <3
        registry.register(new BlockInfo(Blocks.field_150356_k), 3);
        registry.register(new BlockInfo(Blocks.field_150353_l), 3);
        registry.register(new BlockInfo(Blocks.field_150480_ab), 4);
        registry.register(new BlockInfo(Blocks.field_150478_aa), 1);
    }

    public void registerBarrelLiquidBlacklist(BarrelLiquidBlacklistRegistry registry) {
        registry.register(ModBlocks.barrelWood.getTier(), "lava");
        registry.register(ModBlocks.barrelWood.getTier(), "fire_water");
        registry.register(ModBlocks.barrelWood.getTier(), "rocket_fuel");
    }

    public void registerFluidOnTop(FluidOnTopRegistry registry) {
        registry.register(FluidRegistry.LAVA, FluidRegistry.WATER, new BlockInfo(Blocks.field_150343_Z.func_176223_P()));
        registry.register(FluidRegistry.WATER, FluidRegistry.LAVA, new BlockInfo(Blocks.field_150347_e.func_176223_P()));
    }

    public void registerOreChunks(OreRegistry registry) {
        registry.register("gold", new Color("FFFF00"), new ItemInfo(Items.field_151043_k, 0));
        registry.register("iron", new Color("BF8040"), new ItemInfo(Items.field_151042_j, 0));

        //TODO: Better way, will most likely never grab as it is just called before many mods init their oredict
        if (!OreDictionary.getOres("oreCopper").isEmpty()) {
            registry.register("copper", new Color("FF9933"), null);
        }

        if (!OreDictionary.getOres("oreTin").isEmpty()) {
            registry.register("tin", new Color("E6FFF2"), null);
        }

        if (!OreDictionary.getOres("oreAluminium").isEmpty() || !OreDictionary.getOres("oreAluminum").isEmpty()) {
            registry.register("aluminium", new Color("BFBFBF"), null);
        }

        if (!OreDictionary.getOres("oreLead").isEmpty()) {
            registry.register("lead", new Color("330066"), null);
        }

        if (!OreDictionary.getOres("oreSilver").isEmpty()) {
            registry.register("silver", new Color("F2F2F2"), null);
        }

        if (!OreDictionary.getOres("oreNickel").isEmpty()) {
            registry.register("nickel", new Color("FFFFCC"), null);
        }
    }

    public void registerFluidTransform(FluidTransformRegistry registry) {
        registry.register("water", "witchwater", 12000, new BlockInfo[]{new BlockInfo(Blocks.field_150391_bh.func_176223_P())}, new BlockInfo[]{new BlockInfo(Blocks.field_150338_P.func_176223_P()), new BlockInfo(Blocks.field_150337_Q.func_176223_P())});
    }

    public void registerFluidBlockTransform(FluidBlockTransformerRegistry registry) {
        registry.register(FluidRegistry.WATER, new ItemInfo(new ItemStack(ModBlocks.dust)), new ItemInfo(new ItemStack(Blocks.field_150435_aG)));
        registry.register(FluidRegistry.LAVA, new ItemInfo(new ItemStack(Items.field_151137_ax)), new ItemInfo(new ItemStack(Blocks.field_150424_aL)));
        registry.register(FluidRegistry.LAVA, new ItemInfo(new ItemStack(Items.field_151114_aO)), new ItemInfo(new ItemStack(Blocks.field_150377_bs)));
        registry.register(ModFluids.fluidWitchwater, new ItemInfo(new ItemStack(Blocks.field_150354_m)), new ItemInfo(new ItemStack(Blocks.field_150425_aM)));
        registry.register(FluidRegistry.getFluid("milk"), new ItemInfo(new ItemStack(Blocks.field_150338_P)), new ItemInfo(new ItemStack(Blocks.field_180399_cE)), "Slime");
        registry.register(FluidRegistry.getFluid("milk"), new ItemInfo(new ItemStack(Blocks.field_150337_Q)), new ItemInfo(new ItemStack(Blocks.field_180399_cE)), "Slime");

        // Vanilla Concrete
        for (int meta = 0; meta < 16; meta++)
            registry.register(FluidRegistry.WATER, new ItemInfo(new ItemStack(Blocks.field_192444_dS, 1, meta)), new ItemInfo(new ItemStack(Blocks.field_192443_dR, 1, meta)));
    }

    public void registerFluidItemFluid(FluidItemFluidRegistry registry) {
        registry.register(FluidRegistry.WATER, new ItemInfo(ItemResource.getResourceStack(ItemResource.ANCIENT_SPORES)), ModFluids.fluidWitchwater);
    }

    public void registerCrucibleStone(CrucibleRegistry registry) {
        registry.register("cobblestone", FluidRegistry.LAVA, 250);
        registry.register("stone", FluidRegistry.LAVA, 250);
        registry.register("gravel", FluidRegistry.LAVA, 200);
        registry.register("sand", FluidRegistry.LAVA, 100);
        registry.register(new BlockInfo(ModBlocks.dust.func_176223_P()), FluidRegistry.LAVA, 50);

        // 1:1 Back to lava
        registry.register("netherrack", FluidRegistry.LAVA, 1000);
        registry.register("obsidian", FluidRegistry.LAVA, 1000);
    }

    public void registerCrucibleWood(CrucibleRegistry registry) {
        Meltable water = new Meltable(FluidRegistry.WATER.getName(), 250, new BlockInfo(Blocks.field_150362_t, 0));
        registry.register("treeLeaves", FluidRegistry.WATER, 250);
        registry.register("treeSapling", water);
        registry.register("listAllfruit", water);
        registry.register("listAllveggie", water);

        registry.register(new ItemInfo(Blocks.field_150345_g, 0), water);
        registry.register(new ItemInfo(Blocks.field_150345_g, 1), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150362_t, 1)));
        registry.register(new ItemInfo(Blocks.field_150345_g, 2), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150362_t, 2)));
        registry.register(new ItemInfo(Blocks.field_150345_g, 3), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150362_t, 3)));
        registry.register(new ItemInfo(Blocks.field_150345_g, 4), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150361_u, 0)));
        registry.register(new ItemInfo(Blocks.field_150345_g, 5), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150361_u, 1)));
        registry.register(new ItemInfo(Items.field_151034_e), water);
    }

    public void registerMilk(MilkEntityRegistry registry) {
        registry.register("Cow", "milk", 10, 20);
    }

    private float getDropChance(float chance) {
        if (ModConfig.world.isSkyWorld)
            return chance;
        else return chance / 100f * (float) ModConfig.world.normalDropPercent;
    }

    public static Map<BlockInfo, BlockInfo> getLeavesSapling(){
        Map<BlockInfo, BlockInfo> saplingMap = new LinkedHashMap<>();
        saplingMap.put(new BlockInfo(Blocks.field_150362_t, 0), new BlockInfo(Blocks.field_150345_g, 0));
        saplingMap.put(new BlockInfo(Blocks.field_150362_t, 1), new BlockInfo(Blocks.field_150345_g, 1));
        saplingMap.put(new BlockInfo(Blocks.field_150362_t, 2), new BlockInfo(Blocks.field_150345_g, 2));
        saplingMap.put(new BlockInfo(Blocks.field_150362_t, 3), new BlockInfo(Blocks.field_150345_g, 3));
        saplingMap.put(new BlockInfo(Blocks.field_150361_u, 0), new BlockInfo(Blocks.field_150345_g, 4));
        saplingMap.put(new BlockInfo(Blocks.field_150361_u, 1), new BlockInfo(Blocks.field_150345_g, 5));

        return saplingMap;
    }
}
